CREATE TABLE csmbk_fnd_grants (
    ENTERPRISE_ID         NUMBER(18, 0)     NOT NULL,
    SANDBOX_ID            VARCHAR2(256)     NOT NULL,
    GRANT_GUID            VARCHAR2(128)     NOT NULL,
    GRANTEE_TYPE          VARCHAR2(120)     NOT NULL,
    MODULE_ID             VARCHAR2(128)     NOT NULL,
    GRANTEE_KEY           VARCHAR2(512)     NOT NULL,
    MENU_ID               NUMBER(18, 0)     NOT NULL,
    START_DATE            DATE              NOT NULL,
    END_DATE              DATE          ,
    OBJECT_ID             NUMBER(18, 0)     NOT NULL,
    INSTANCE_TYPE         VARCHAR2(120)     NOT NULL,
    INSTANCE_SET_ID       NUMBER(18, 0) ,
    INSTANCE_PK1_VALUE    VARCHAR2(1024),
    INSTANCE_PK2_VALUE    VARCHAR2(1024),
    INSTANCE_PK3_VALUE    VARCHAR2(1024),
    INSTANCE_PK4_VALUE    VARCHAR2(1024),
    INSTANCE_PK5_VALUE    VARCHAR2(1024),
    PARAMETER1            VARCHAR2(1024),
    PARAMETER2            VARCHAR2(1024),
    PARAMETER3            VARCHAR2(1024),
    PARAMETER4            VARCHAR2(1024),
    PARAMETER5            VARCHAR2(1024),
    PARAMETER6            VARCHAR2(1024),
    PARAMETER7            VARCHAR2(1024),
    PARAMETER8            VARCHAR2(1024),
    PARAMETER9            VARCHAR2(1024),
    PARAMETER10           VARCHAR2(1024),
    NAME                  VARCHAR2(320) ,
    DESCRIPTION           VARCHAR2(4000),
    CREATED_BY            VARCHAR2(256)     NOT NULL,
    CREATION_DATE         TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY       VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_DATE      TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_LOGIN     VARCHAR2(128) ,
    PROGRAM_NAME          VARCHAR2(120) ,
    PROGRAM_TAG           VARCHAR2(120) ,
    GRANT_TYPE            VARCHAR2(120)     NOT NULL,
    ROLE_NAME             VARCHAR2(1024),
    IS_ENTERPRISE_ROLE    VARCHAR2(16)  ,
    J2EE_APP_NAME         VARCHAR2(1024),
    ROLE_NAME_SPACE       VARCHAR2(1024),
    COMPILE_FLAG          VARCHAR2(16)      NOT NULL,
    ENTERPRISE_ID         NUMBER(18, 0)     NOT NULL,
    SANDBOX_ID            VARCHAR2(256)     NOT NULL,
    GRANT_GUID            VARCHAR2(128)     NOT NULL,
    GRANTEE_TYPE          VARCHAR2(120)     NOT NULL,
    MODULE_ID             VARCHAR2(128)     NOT NULL,
    GRANTEE_KEY           VARCHAR2(512)     NOT NULL,
    MENU_ID               NUMBER(18, 0)     NOT NULL,
    START_DATE            DATE              NOT NULL,
    END_DATE              DATE          ,
    OBJECT_ID             NUMBER(18, 0)     NOT NULL,
    INSTANCE_TYPE         VARCHAR2(120)     NOT NULL,
    INSTANCE_SET_ID       NUMBER(18, 0) ,
    INSTANCE_PK1_VALUE    VARCHAR2(1024),
    INSTANCE_PK2_VALUE    VARCHAR2(1024),
    INSTANCE_PK3_VALUE    VARCHAR2(1024),
    INSTANCE_PK4_VALUE    VARCHAR2(1024),
    INSTANCE_PK5_VALUE    VARCHAR2(1024),
    PARAMETER1            VARCHAR2(1024),
    PARAMETER2            VARCHAR2(1024),
    PARAMETER3            VARCHAR2(1024),
    PARAMETER4            VARCHAR2(1024),
    PARAMETER5            VARCHAR2(1024),
    PARAMETER6            VARCHAR2(1024),
    PARAMETER7            VARCHAR2(1024),
    PARAMETER8            VARCHAR2(1024),
    PARAMETER9            VARCHAR2(1024),
    PARAMETER10           VARCHAR2(1024),
    NAME                  VARCHAR2(320) ,
    DESCRIPTION           VARCHAR2(4000),
    CREATED_BY            VARCHAR2(256)     NOT NULL,
    CREATION_DATE         TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY       VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_DATE      TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_LOGIN     VARCHAR2(128) ,
    PROGRAM_NAME          VARCHAR2(120) ,
    PROGRAM_TAG           VARCHAR2(120) ,
    GRANT_TYPE            VARCHAR2(120)     NOT NULL,
    ROLE_NAME             VARCHAR2(1024),
    IS_ENTERPRISE_ROLE    VARCHAR2(16)  ,
    J2EE_APP_NAME         VARCHAR2(1024),
    ROLE_NAME_SPACE       VARCHAR2(1024),
    COMPILE_FLAG          VARCHAR2(16)      NOT NULL
);
